-- Update triggers
-- Task table foreign keys insert constraint
DROP TRIGGER task_insert;
DROP TRIGGER task_deleted_insert;

CREATE TRIGGER task_insert
BEFORE INSERT ON task
BEGIN
    SELECT CASE
        WHEN (SELECT id FROM project WHERE id = NEW.parent) IS NULL AND (SELECT id FROM project_deleted WHERE id = NEW.parent) IS NULL
            THEN RAISE (ABORT, 'TASK_PARENT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT id FROM context WHERE id = NEW.context) IS NULL AND (SELECT id FROM context_deleted WHERE id = NEW.context) IS NULL AND NEW.context IS NOT NULL
            THEN RAISE (ABORT, 'TASK_CONTEXT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN NEW.predefined_id <> 0 AND (SELECT COUNT(*) FROM task WHERE predefined_id = NEW.predefined_id) > 0
            THEN RAISE (IGNORE)
    END;
END;

CREATE TRIGGER task_deleted_insert
BEFORE INSERT ON task_deleted
BEGIN
    SELECT CASE
        WHEN (SELECT id FROM project WHERE id = NEW.parent) IS NULL AND (SELECT id FROM project_deleted WHERE id = NEW.parent) IS NULL
            THEN RAISE (ABORT, 'TASK_PARENT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT id FROM context WHERE id = NEW.context) IS NULL AND (SELECT id FROM context_deleted WHERE id = NEW.context) IS NULL AND NEW.context IS NOT NULL
            THEN RAISE (ABORT, 'TASK_CONTEXT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN NEW.predefined_id <> 0 AND (SELECT COUNT(*) FROM task WHERE predefined_id = NEW.predefined_id) > 0
            THEN RAISE (IGNORE)
    END;
END;
