DROP TRIGGER task_insert;
CREATE TRIGGER task_insert
BEFORE INSERT ON task
BEGIN
    SELECT CASE
        WHEN (SELECT id FROM project WHERE id = NEW.parent) IS NULL
            THEN RAISE (ABORT, 'TASK_PARENT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT id FROM context WHERE id = NEW.context) IS NULL AND NEW.context IS NOT NULL
            THEN RAISE (ABORT, 'TASK_CONTEXT_FK_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN NEW.predefined_id <> 0 AND (SELECT COUNT(*) FROM task WHERE predefined_id = NEW.predefined_id) > 0
            THEN RAISE (IGNORE)
    END;
END;

DROP TRIGGER task_deleted_insert;

-- Deleted project table constraints
DROP TRIGGER project_deleted_insert;
CREATE TRIGGER project_deleted_insert
BEFORE INSERT ON project_deleted
BEGIN
    SELECT CASE
        WHEN NEW.id = NEW.parent
            THEN RAISE (ABORT, 'PROJECT_PARENT_INSERT_SECOND_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT COUNT(*) FROM project WHERE type = 1) >= 1 AND NEW.type = 1
            THEN RAISE (ABORT, 'INBOX_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT COUNT(*) FROM project WHERE type = 2) >= 1 AND NEW.type = 2
            THEN RAISE (ABORT, 'SINGLE_ACTIONS_INSERT_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT type FROM project WHERE id = NEW.parent) = 1
            THEN RAISE (ABORT, 'PROJECT_PARENT_IS_OF_INVALID_TYPE_VIOLATION')
    END;

    SELECT CASE
        WHEN (SELECT type FROM project WHERE id = NEW.parent) = 2
            THEN RAISE (ABORT, 'PROJECT_PARENT_IS_OF_INVALID_TYPE_VIOLATION')
    END;

    SELECT CASE
        WHEN NEW.predefined_id <> 0 AND (SELECT COUNT(*) FROM project WHERE predefined_id = NEW.predefined_id) > 0
            THEN RAISE (IGNORE)
    END;
END;
