ALTER TABLE context ADD COLUMN parent TEXT DEFAULT NULL;
ALTER TABLE task ADD COLUMN period_type INTEGER DEFAULT 0;
ALTER TABLE task ADD COLUMN period_interval INTEGER DEFAULT 0;
ALTER TABLE task ADD COLUMN days INTEGER DEFAULT 0;

-- Recreate context table constraints
DROP TRIGGER context_insert;
CREATE TRIGGER context_insert
BEFORE INSERT ON context
BEGIN
    SELECT CASE
        WHEN NEW.predefined_id <> 0 AND (SELECT COUNT(*) FROM project WHERE predefined_id = NEW.predefined_id) > 0
            THEN RAISE (IGNORE)
    END;

    SELECT CASE
        WHEN (SELECT id FROM context WHERE id = NEW.parent) IS NULL AND NEW.parent IS NOT NULL
            THEN RAISE (ABORT, 'CONTEXT_PARENT_INSERT_FIRST_VIOLATION')
    END;
END;
